Index: examples/python_tests/access_rt2/attr.py
===================================================================
--- examples/python_tests/access_rt2/attr.py	(revision 669b4810acfbeee6bdec4a2443a99b2994efedc8)
+++ examples/python_tests/access_rt2/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
@@ -7,7 +7,11 @@
 """
 
+# See README in this directory for the semantics of the example.  This file
+# constructs the credentials described and puts copies into this directory
+
 import os
 import ABAC
 
+# Keystore is the directory containing the principal credentials.
 keystore=os.environ["keystore"]
 
@@ -15,6 +19,8 @@
 print "ABAC version %s" % ctxt.version()
 
+# Load existing principals
 ctxt.load_directory(keystore)
 
+# Print the principals and credentials in the keystore
 out = ctxt.context_principals()
 print "...initial principal set..."
@@ -29,12 +35,15 @@
 print "\n"
 
+# Construct a "Joe" principal and load it into the ABAC context
 joeID=ABAC.ID("Joe", 0)
 ctxt.load_id(joeID)
-#joeID.id_write_privkey("Joe_IDKEY.pem")
-#joeID.id_write_cert("Joe_IDKEY.pem")
+# Write out the Joe Principal to 2 files - one for the key and one for the
+# identity.  The identity can be shared, but the key must be kept secret.
 joeID.id_write_privkey("Joe_private.pem")
 joeID.id_write_cert("Joe_ID.pem")
+# Keep a copy if Joe's key identifier as a string.
 joe=joeID.id_keyid()
 
+# Load alpha and bob from local files (created by ./setup.py
 alphaID=ABAC.ID("Alpha_ID.pem")
 alphaID.id_load_privkey_file("Alpha_private.pem");
@@ -46,14 +55,23 @@
 
 ################################################
+# Create the credential
 # [keyid:alpha].role:access([string:'Read'],[urn:'file//fileB']) <- [keyid:bob]
 param1=ABAC.DataTerm("string", "'Read'")
 param2=ABAC.DataTerm("urn","'file//fileB'")
 head = ABAC.Role(alpha,"access")
+
+# Attach the parameters to the access role
 head.role_add_data_term(param1)
 head.role_add_data_term(param2)
 tail = ABAC.Role(bob)
+
+# Hook the head to the tail
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# create the credential
 attr.attribute_bake()
+
+# Save a copy and add the credential to the context
 attr.attribute_write_cert("Alpha_access_fileB__Bob_attr.der")
 ctxt.load_attribute_file("Alpha_access_fileB__Bob_attr.der")
@@ -61,4 +79,6 @@
 print attr.typed_string()
 print "\n"
+
+# Constructing the others are similar
 
 #################################################
Index: examples/python_tests/access_rt2/query.py
===================================================================
--- examples/python_tests/access_rt2/query.py	(revision 669b4810acfbeee6bdec4a2443a99b2994efedc8)
+++ examples/python_tests/access_rt2/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
@@ -12,12 +12,17 @@
 import ABAC
 
+# Run the queries described in README
+
 ctxt = ABAC.Context()
 
 # print "ABAC version %s" % ctxt.version()
 
+# If a keystore is given in the environment, pre-load those credentials
 keystore=os.environ["keystore"]
 
 ctxt.load_directory(keystore)
 
+# Load the principals created in ./attr.py and ./setup.py.  Each has an
+# identity and private key.
 alphaID=ABAC.ID("Alpha_ID.pem");
 alphaID.id_load_privkey_file("Alpha_private.pem");
@@ -34,4 +39,9 @@
 joe=joeID.id_keyid()
 
+# Construct and run the queries.  In each case we create a role object and a
+# principal and call the query method on the context.  The contents of the
+# proof are printed for successful queries.
+# role is the role to look for
+# p is the principal to check.
 ##########################################################################
 # role =[keyid:alpha].role:access([string:'Read'],[urn:'file//fileA'])
@@ -42,6 +52,6 @@
 role.role_add_data_term(param1)
 role.role_add_data_term(param2)
+
 p = ABAC.Role(bob)
-
 print "\n===good============ Alpha.access(Read,fileA)<-?-Bob"
 out = ctxt.query(role, p)
Index: examples/python_tests/access_rt2/setup.py
===================================================================
--- examples/python_tests/access_rt2/setup.py	(revision 669b4810acfbeee6bdec4a2443a99b2994efedc8)
+++ examples/python_tests/access_rt2/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
@@ -9,4 +9,7 @@
 import ABAC
 
+# See README for the semantics.  This creates two prinicpals (Alpha and Bob)
+# used by the example.  The ./attrs.py file creates the policy credentials.
+
 ctxt = ABAC.Context()
 